function [G,M]=Convert2G(data)
% size(data)=[n,J] 
% assume there are J variables in each row of data, and there are k_j categorial values for each variable j 
% the G is a colleciton of g_j (size(g_j)=[n,k_j])
[N,J]=size(data);
G=cell(1,J);
M=cell(1,J);
categoryNum=[2,2,2,5,6,2,2,2,2,2];
for j=1:J
  dist_values=unique(data(:,j));            % find the distinct categorial values for each variable
  dist_values=sort(dist_values);            % sort all categorical values by order
  if ismember(0, dist_values)               % 0 denotes missing data 
    idx_0=find(dist_values==0);             % find the location of 0
    dist_values(idx_0)=[];                  % remove 0
  end 
  num_category=categoryNum(j);
  
  g_j=zeros(N,num_category);               % categorial value indication matrix for variable j
  for i=1:N
    cat_idx=find(dist_values==data(i,j));
    g_j(i,cat_idx)=1;   
  end;  
  m_j=eye(N);                              % m_j matrix is to handl missing data
  for i=1:N
    m_j(i,i)=sum(g_j(i,:));
  end;
  G{1,j}=g_j;
  M{1,j}=m_j;
end;
end
